using System;
using System.Web;
using System.Web.Routing;
using MvcGallery3.Utils;

namespace MvcGallery3.Extensions.Constraints
{
    public class EvenConstraint : IRouteConstraint
    {
        public Boolean Match(HttpContextBase httpContext, Route route, String parameterName, RouteValueDictionary values, RouteDirection routeDirection)
        {
            // Check whether the parameter is an even number
            var paramValue = values[parameterName] as String;
            if (paramValue == null)
                return false;

            var id = paramValue.ToInt();
            return id%2 == 0; 
        }
    }
}