using System;
using System.Web.Mvc;
using System.Web.Routing;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;

namespace MvcGallery3.Extensions.Factory
{
    public class UnityControllerFactory : DefaultControllerFactory
    {
        public static IUnityContainer Container { get; private set; }

        public UnityControllerFactory()
        {
            Container = new UnityContainer();
            Container.LoadConfiguration();
        }

        protected override IController GetControllerInstance(RequestContext requestContext, Type controllerType)
        {
            if (controllerType == null)
                return null;
            return Container.Resolve(controllerType) as IController;
        }

        public override void ReleaseController(IController controller)
        {
            Container.Teardown(controller);
        }
    }
}