using System;
using System.Web;

namespace MvcGallery3.Utils
{
    public static class RequestExtensions
    {
        /// <summary>
        /// Returns a string that combines current server string and specified path
        /// </summary>
        /// <param name="request">Request HTTP object</param>
        /// <param name="path">Path to add</param>
        /// <returns></returns>
        public static String ReplacePath(this HttpRequestBase request, String path)
        {
            if (request == null)
                throw new ArgumentNullException("request");
            if (request.Url == null)
                throw new ArgumentNullException("url");

            return String.Format("{0}://{1}/{2}", request.Url.Scheme, request.Url.Authority, path.TrimStart('/'));
        }
    }
}