﻿using System;
using System.Text;

namespace MvcGallery3.Utils
{
    public static class StringExtensions
    {
        public static String AsCommaSeparated(this String[] theStringArray)
        {
            var builder = new StringBuilder();
            foreach(var s in theStringArray)
            {
                builder.AppendFormat(" {0},", s);
            }
            var output = builder.ToString();
            return output.TrimStart(' ').TrimEnd(',');
        }

        public static Uri AsUri(this String theString)
        {
            return new Uri(theString);
        }

        public static Int32 ToInt(this String theString, Int32 defaultValue=Int32.MinValue)
        {
            var number = defaultValue;
            var result = Int32.TryParse(theString, out number);
            return number;
        }
    }
}
