using System;
using System.Collections.Generic;
using System.IO;
using System.Net;
using System.ServiceModel.Syndication;
using System.Web.Mvc.Async;
using System.Xml;

namespace AsyncApp.Common
{
    public class NewsHumbleObject : INewsHumbleObject
    {
        #region ITennisNewsHumbleObject Members

        public void Prepare(AsyncManager asyncManager)
        {
            asyncManager.OutstandingOperations.Increment();
        }

        public void GetFeedItems(String url, AsyncManager asyncManager)
        {
            var uri = new Uri(url);
            var client = new WebClient();
            client.DownloadStringCompleted += (sender, e) =>
                                                    {
                                                        var feed = ProcessToFeed(e.Result);
                                                        asyncManager.Parameters["feedItems"] = feed;
                                                        asyncManager.OutstandingOperations.Decrement();
                                                    };
            client.DownloadStringAsync(uri);
        }

        #endregion

        private static IList<SyndicationItem> ProcessToFeed(String xml)
        {
            var textReader = new StringReader(xml);
            var xmlReader = XmlReader.Create(textReader);
            var feed = SyndicationFeed.Load(xmlReader);
            return feed == null ? null : new List<SyndicationItem>(feed.Items);
        }

    }
}