using System.Collections.Generic;
using System.Text;
using System.Web.Mvc;
using GridDemo.Models;

namespace GridDemo.Common
{
    public static class TableHelper
    {
        // Table is NOT a good name here. It is not a generic TABLE generator.
        public static MvcHtmlString Table(this HtmlHelper helper, ICollection<City> cities)
        {
            var builder = new StringBuilder();
            builder.AppendFormat("<table>");
            builder.AppendFormat("<thead><th>City</th><th>Country</th><th>Been there?</th></thead>");

            foreach(var city in cities)
            {
                builder.AppendFormat("<tr><td>{0}</td><td>{1}</td><td>{2}</td></tr>",
                    city.Name, city.Country, city.Visited ?"Yes" :"No");
            }

            builder.AppendFormat("</table>");
            return MvcHtmlString.Create(builder.ToString());
        }
    }
}