﻿using System;
using System.Web.Mvc;
using System.Linq;
using Northwind.DAL;
using Northwind.Model;
using ServerControls.Models;

namespace ServerControls.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(/* No chances model binding is gonna work, not even with ClientIDMode=Static :) */)
        {
            #region Little hack
            // This hack is required because the ID of the drop-down is hardly 
            // the same you set in the markup: it can be spoiled by naming containers.
            var id = String.Empty;
            var eventTarget = HttpContext.Request["__EVENTTARGET"];
            object temp = HttpContext.Request[eventTarget];
            if (temp != null)
                id = (String)temp;
            #endregion

            ViewBag.Message = "Programming ASP.NET MVC3";

            var context = new NorthwindEntities();
            var customers = (from c in context.Customers
                             select c).ToList();
            customers.Insert(0, new Customer {CompanyName = "<None>", CustomerID=""});

            var orders = (from o in context.Orders
                          where o.CustomerID == id
                          select o).ToList(); 
            var model = new HomeIndexViewModel() { Customers = customers, SelectedCustomerId = id, Orders = orders };
            return View(model);
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
