﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using GridDemo.Models;
using MvcGallery3.Extensions.Html;

namespace GridDemo.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Block()
        {
            ViewBag.Header = "Cities in the world";

            // Prepare data to send
            var cities = new List<City>();
            cities.Add(new City() { Name = "New York", Country = "USA", Visited = true });
            cities.Add(new City() { Name = "Sydney", Country = "Australia", Visited = true });
            cities.Add(new City() { Name = "Madrid", Country = "Spain", Visited = false });
            cities.Add(new City() { Name = "Beijing", Country = "China", Visited = false });
            cities.Add(new City() { Name = "London", Country = "UK", Visited = true });
            return View(cities);
        }

        public ActionResult Helper()
        {
            ViewBag.Header = "Cities in the world";

            // Prepare data to send
            var cities = new List<City>();
            cities.Add(new City() { Name = "New York", Country = "USA", Visited = true });
            cities.Add(new City() { Name = "Sydney", Country = "Australia", Visited = true });
            cities.Add(new City() { Name = "Madrid", Country = "Spain", Visited = false });
            cities.Add(new City() { Name = "Beijing", Country = "China", Visited = false });
            cities.Add(new City() { Name = "London", Country = "UK", Visited = true });
            return View(cities);
        }

        public ActionResult Pager(Int32? pageIndex)
        {
            ViewBag.Header = "Cities in the world";

            // Prepare data to send
            var cities = new List<City>();
            cities.Add(new City() { Name = "New York", Country = "USA", Visited = true });
            cities.Add(new City() { Name = "Sydney", Country = "Australia", Visited = true });
            cities.Add(new City() { Name = "Madrid", Country = "Spain", Visited = false });
            cities.Add(new City() { Name = "Beijing", Country = "China", Visited = false });
            cities.Add(new City() { Name = "London", Country = "UK", Visited = true });
            cities.Add(new City() { Name = "Ljubljana", Country = "Slovenia", Visited = true });

            // Set index page to display
            var index = pageIndex.HasValue ? pageIndex.Value : 1;
            index = index < 1 ? 1 : index;

            var model = new PagedViewModel<City>
            {
                PageIndex = index,
                PageSize = 2,
                DataSource = cities
            };

            return View(model);
        }
    }
}
