﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using RazorEngine.Models;

namespace RazorEngine.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Registered view engines:";
            ViewBag.EngineList = GetRegisteredViewEngines();

            return View();
        }

        public ActionResult About()
        {
            ViewData["Message"] = "Thank you for choosing this book!";
            return PartialView("");
        }

        public ActionResult Cities()
        {
            ViewBag.Header = "Cities in the world";

            // Prepare data to send
            var cities = new List<City>();
            cities.Add(new City() { Name = "New York", Country = "USA", Visited = true });
            cities.Add(new City() { Name = "Sydney", Country = "Australia", Visited = true });
            cities.Add(new City() { Name = "Madrid", Country = "Spain", Visited = false });
            cities.Add(new City() { Name = "Beijing", Country = "China", Visited = false });
            cities.Add(new City() { Name = "London", Country = "UK", Visited = true });
            return View(cities);
        }

        private static IList<String> GetRegisteredViewEngines()
        {
            return ViewEngines.Engines.Select(engine => engine.ToString()).ToList();
        }
    }
}
