﻿using System.Web.Mvc;
using Prg.WorkerServices.Abstractions;
using Prg.WorkerServices.Customers;

namespace Prg.Controllers
{
    public class HomeController : Controller
    {
        private readonly ICustomerWorkerServices _service;

        public HomeController()
            : this(new CustomerWorkerServices())
        {
        }
        public HomeController(ICustomerWorkerServices service)
        {
            _service = service;
        }

        public ActionResult Index()
        {
            var model = _service.FindAllCustomers();
            return View(model);
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
