﻿using System;
using System.Web.Mvc;
using System.Web.Routing;


namespace TryCatch
{
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default",  
                "{controller}/{action}/{id}",  
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } 
            );

            // Catch-all route
            routes.MapRoute(
              "Catchall",
              "{*anything}",
              new { controller = "Error", action = "Missing" }
            );
        }

        protected void Application_Start()
        {
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }

        protected void Application_Error(Object sender, EventArgs e) 
        {
            //// Code that runs when an unhandled error occurs
            //var exception = Server.GetLastError();
            //if (exception == null)
            //    return;

            //var mail = new MailMessage { From = new MailAddress("dino@idesign.net") };
            //mail.To.Add(new MailAddress("dino@idesign.net"));
            //mail.Subject = "Site Error at " + DateTime.Now;
            //mail.Body = "Error Description: " + exception.Message;
            //var server = new SmtpClient { Host = "mail.orcsweb.com" };
            //server.Send(mail);

            //// Clear the error
            //Server.ClearError();

            //// Redirect (home)
            //Response.Redirect("/home/error");
        }
    }
}