﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Web.Mvc;
using EmbRes.Resources;
using EmbRes.ViewModels.Home;

namespace EmbRes.Controllers
{
    public class HomeController : Controller
    {
        /// <summary>
        /// Display the home page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult Index()
        {
            var model = new HomeIndexViewModel
                            {
                                Title = Strings.HomeIndexTitle,
                                Message = String.Format(Strings.WelcomeMessageFormat, Strings.AppName)
                            };
            return View(model);
        }

        /// <summary>
        /// Display the About page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult About()
        {
            var model = new AboutUsViewModel
                            {
                                Title = Strings.HomeAboutTitle,
                                ContactInfo = Strings.Contact
                            };
            return View(model);
        }

        public Object Image(String name)
        {
            var bits = (Bitmap) HttpContext.GetGlobalResourceObject("AllResources", name);
            Response.ContentType = "image/jpeg";
            bits.Save(Response.OutputStream, ImageFormat.Jpeg);
            
            return bits;
        }
    }
}
