﻿using System.Web.Mvc;
using IoCFatFree.Resources;
using IoCFatFree.ViewModels.Home;
using IoCFatFree.WorkerServices.Abstractions;

namespace IoCFatFree.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHomeServices _workerService;

        public HomeController(IHomeServices service)
        {
            _workerService = service;
        }


        /// <summary>
        /// Display the home page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult Index()
        {
            var model = _workerService.GetHomeViewModel();
            return View(model);
        }

        /// <summary>
        /// Display the About page
        /// </summary>
        /// <returns>HTML</returns>
        public ActionResult About()
        {
            var model = new AboutUsViewModel
                            {
                                Title = Strings.HomeAboutTitle,
                                ContactInfo = Strings.Contact
                            };
            return View(model);
        }
    }
}
