﻿using System;
using System.Linq;
using System.Threading;
using System.Web.Mvc;
using Misc.Resources;
using Misc.ViewModels.Home;
using MvcGallery3.Extensions.Filters;
using MvcGallery3.Extensions.Filters.Axpect;

namespace Misc.Controllers
{
    public class HomeController : Controller //AxpectController
    {
        public ActionResult Index()
        {
            // Add a bit of delay for demo purposes ...
            AddDelay();

            var model = new HomeIndexViewModel
                            {
                                Title = Strings.HomeIndexTitle,
                                Message = String.Format(Strings.WelcomeMessageFormat, Strings.AppName)
                            };
            return View(model);
        }

        //[AddHeader(Name="Action", Value="About")]
        [ReportDuration(Name="MvcGallery3")]
        [Compress]
        public ActionResult About()
        {
            // Add a bit of delay for demo purposes ...
            AddDelay();

            var model = new AboutUsViewModel
                            {
                                Title = Strings.HomeAboutTitle,
                                ContactInfo = Strings.Contact
                            };
            return View(model);
        }

        [BrowserSpecific]
        public ActionResult Multi()
        {
            return View();
        }

        // Dynamically bound to action filters
        public ActionResult Test()
        {
            var model = new HomeTestViewModel
            {
                Title = Strings.HomeIndexTitle
            };
            return View(model);
        }

        #region Helpers
        private static void AddDelay()
        {
            var ms = new Random().Next(100, 500);
            Thread.Sleep(ms);
        }
        #endregion

        #region Embedded Filters
        protected DateTime StartTime;

        protected override void OnActionExecuted(ActionExecutedContext filterContext)
        {
            var action = filterContext.ActionDescriptor.ActionName;
            if (String.Equals(action, "index", StringComparison.CurrentCultureIgnoreCase))
            {
                var timeSpan = DateTime.Now - StartTime;
                filterContext.RequestContext.HttpContext.Response.AddHeader("MvcGallery3", timeSpan.Milliseconds.ToString());
            }

            base.OnActionExecuted(filterContext);
        }

        protected override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            var action = filterContext.ActionDescriptor.ActionName;
            if (String.Equals(action, "index", StringComparison.CurrentCultureIgnoreCase))
            {
                StartTime = DateTime.Now;
            }

            base.OnActionExecuting(filterContext);
        }
        #endregion
    }
}
