﻿using System.Web.Mvc;
using System.Web.Routing;
using MvcGallery3.Extensions.ViewEngines;

namespace SwitchLang2
{

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);

            ViewEngines.Engines.Clear();
            ViewEngines.Engines.Add(new LocalizableRazorViewEngine());

            // You can stack up view engines but consider that search for the right engine
            // ends at first match. In other words, in this scenario you either get 
            // localization or support for a different partial view location. To have both
            // feature you need a single engine that sums up both capabilities.
            ViewEngines.Engines.Add(new PartialRazorViewEngine());
        }
    }
}