﻿using System;
using System.Web.Mvc;
using MvcGallery3.Extensions.Filters;
using SampleApp.WorkerServices;

namespace SampleApp.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHomeServices _service;

        public HomeController() : this (new HomeServices())
        {
        }
        public HomeController(IHomeServices service)
        {
            _service = service;
        }

        public ActionResult Index()
        {
            _service.GetIndexViewModel(ViewBag);
            return View();
        }

        [AddHeader(Name="Author", Value="Dino")]
        public ActionResult About()
        {
            return View();
        }

        public ActionResult Output()
        {
            HttpContext.Response.Write("Hello");
            return View("index");
        }

        public ActionResult SetColor()
        {
            Session["PreferredColor"] = "green";
            return View("index");
        }

        public ActionResult GetColor()
        {
            var o = Session["PreferredColor"];
            if (o == null)
                ViewData["Color"] = "No preferred color";
            else
                ViewData["Color"] = o as String;

            return View("index");
        }
    }
}
