﻿using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using MvcGallery3.Extensions.Constraints;

namespace SampleApp
{
    public class MvcApplication : HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute("NumericRoute", "product/code/{id}", 
                new { controller = "Product", action = "Code" },
                new { id = @"\d{3}" });
            routes.MapRoute("NumericRouteEven", "product/id/{id}",
                new { controller = "Product", action = "Find" },
                new { id = new EvenConstraint() });
            routes.MapRoute("Default", "{controller}/{action}/{id}",  
                new { controller = "Home", action = "Index", id = UrlParameter.Optional });
        }

        protected void Application_Start()
        {
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}